
import Happinessctrl as hc
import tkinter
import tkinter as tk
import tkinter as ttk
import networkx as nx
from tkinter import messagebox, filedialog
from tkinter.ttk import Combobox, Progressbar
from pandastable import Table
import matplotlib
import threading, time
from matplotlib.figure import Figure
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg
import matplotlib.pyplot as plt
matplotlib.use("TkAgg")

graph_option = [
    ("Bar", "Bar"),
    ("Network", "Network"),
]


class UI(tk.Tk):

    def __init__(self, Happinessctrl: hc):
        super().__init__()
        self.title("Happiness")
        self.geometry("400x400")
        self.happinessctrl = Happinessctrl
        self.title("Happiness around the world")
        self.geometry("400x400")
        self.region = tk.StringVar()
        self.graph_region = tk.StringVar()
        self.country = tk.StringVar()
        self.graph_type = tk.StringVar()
        self.graph = tk.StringVar()
        self['background'] = '#C1D5F0'
        self.init_components()

    def init_components(self):
        """
        Initialize the components of the GUI
        """

        # Create the label
        self.label1 = ttk.Label(self, text="World Happiness", background='#C1D5F0', font=(
            "Bubblegum", 18), foreground='#4d7902')
        self.label1.place(relx=0.5, rely=0.1, anchor=tk.CENTER)

        # Create the button
        self.button1 = ttk.Button(self, text="Look for Data", font=(
            "Bubblegum", 12), background='#C1D5F0', foreground='#000000', command=self.info_window)
        self.button1.place(relx=0.5, rely=0.45, anchor=tk.CENTER)

        # Create the button
        self.button2 = ttk.Button(self, text="Plot a graph", font=(
            "Bubblegum", 12), background='#C1D5F0', foreground='#000000', command=self.graph_window)
        self.button2.place(relx=0.5, rely=0.60, anchor=tk.CENTER)

        # Create the exit button
        self.button3 = ttk.Button(self, text="Exit", font=(
            "Bubblegum", 12), background='#C1D5F0', foreground='#000000', command=self.destroy)
        self.button3.place(relx=0.5, rely=0.75, anchor=tk.CENTER)

    def info_window(self):
        """
        Open a new window with the data after the button is clicked.
        """
        self.info_window = tk.Toplevel(self)
        self.info_window.title("Data")
        self.info_window.geometry("800x750")
        self.info_window['background'] = '#C1D5F0'
        self.withdraw()

        # Create the filter labelFrame
        self.filter_label = ttk.LabelFrame(self.info_window, text="Filter", font=(
            "Bubblegum", 12), background='#C1D5F0', foreground='#000000')
        self.filter_label.place(relx=0.05, rely=0.05,
                                anchor="nw", height=70, width=350)
        self.filter_label.columnconfigure(0, weight=1)

        self.region_filter = Combobox(self.filter_label, textvariable=self.region, font=(
            "Bubblegum", 12), background='#C1D5F0', foreground='#000000', values=self.happinessctrl.region_list())
        self.region_filter.place(relx=0.05, rely=0.5, anchor="w")
        self.region_filter.bind("<FocusIn>", self.happinessctrl.defocus)
        self.region.trace(
            "w", lambda *args: self.update_pandas(self.region.get()))

        # Create the reset button that reset the filter
        self.reset_button = ttk.Button(self.filter_label, text="Reset", font=(
            "Bubblegum", 12), background='#C1D5F0', foreground='#000000', command=self.reset_data_table)
        self.reset_button.place(relx=0.9, rely=0.5, anchor="e")

        # create a back to main window button at the bottom left of the window
        self.back_button = ttk.Button(self.info_window, text="Back", font=(
            "Bubblegum", 12), background='#C1D5F0', foreground='#000000', command=self.back_from_info)
        self.back_button.place(relx=0.05, rely=0.95, anchor="sw")

        # Create the data that shows the data
        self.data_table = ttk.LabelFrame(self.info_window, text="Data", font=(
            "Bubblegum", 12), background='#C1D5F0', foreground='#000000')
        self.data_table.place(relx=0.05, rely=0.15,
                              anchor="nw", height=550, width=700)
        self.data_table.columnconfigure(0, weight=1)

        # Create the table that show the data and update based on the filter
        self.table = Table(
            self.data_table, dataframe=self.happinessctrl.filter_data())
        self.table.show()

    def graph_window(self):
        """
        Open a new window with the data after the button is clicked.
        """
        self.graph_windows = tk.Toplevel(self)
        self.graph_windows.title("Graph")
        self.graph_windows.geometry("725x700")
        self.graph_windows['background'] = '#C1D5F0'
        self.withdraw()

        # Create the filter labelFrame
        self.filter_label = ttk.LabelFrame(self.graph_windows, text="Filter", font=(
            "Bubblegum", 12), background='#C1D5F0', foreground='#000000')
        self.filter_label.grid(row=0, column=0, padx=10, pady=10, sticky="nw")
        self.filter_label.columnconfigure(0, weight=1)

        # Create the region filter
        self.region_filter = Combobox(self.filter_label, textvariable=self.graph_region, font=(
            "Bubblegum", 12), background='#C1D5F0', foreground='#000000', values=self.happinessctrl.region_list())
        self.region_filter.grid(row=0, column=0, padx=10, pady=2.5, sticky="w")
        self.region_filter.bind("<FocusIn>", self.happinessctrl.defocus)
        self.region_filter.bind("<<ComboboxSelected>>", self.country_option)

        # Create the country filter that based on region filter
        self.country_filter = Combobox(self.filter_label, textvariable=self.country,  font=(
            "Bubblegum", 12), background='#C1D5F0', foreground='#000000', values=self.country_option)
        self.country_filter.grid(
            row=0, column=1, padx=10, pady=2.5, sticky="w")
        self.country_filter.bind("<FocusIn>", self.happinessctrl.defocus)
        

        # Option to plot a graph
        self.graph_option = Combobox(self.filter_label, textvariable=self.graph, font=(
            "Bubblegum", 12), background='#C1D5F0', foreground='#000000', values=self.happinessctrl.option(), width=45)
        self.graph_option.grid(
            row=1, column=0, columnspan=2, padx=10, pady=5, sticky="w")
        self.graph_option.bind("<FocusIn>", self.happinessctrl.defocus)

        # Create the graph type radio button
        text1, val1 = graph_option[0]
        self.bar_button = ttk.Radiobutton(self.filter_label, text=text1, variable=self.graph_type, value=val1, font=("Bubblegum", 12), background='#C1D5F0', foreground='#000000')
        self.bar_button.grid(row=0, column=2, padx=10, pady=5, sticky="w")

        text2, val2 = graph_option[1]
        self.network_button = ttk.Radiobutton(self.filter_label, text=text2, variable=self.graph_type, value=val2, font=("Bubblegum", 12), background='#C1D5F0', foreground='#000000')
        self.network_button.grid(row=1, column=2, padx=10, pady=5, sticky="w")
        
        

        # Create the plot button that plot the graph
        self.plot_button = ttk.Button(self.filter_label, text="Plot", font=(
            "Bubblegum", 12), background='#C1D5F0', foreground='#000000', command=self.update_graph)
        self.plot_button.grid(row=0, column=3, padx=10, pady=5, sticky="w")

        # Create the reset button that reset the filter
        self.reset_button = ttk.Button(self.filter_label, text="Reset", font=(
            "Bubblegum", 12), background='#C1D5F0', foreground='#000000', command=self.reset_data)
        self.reset_button.grid(row=1, column=3, padx=10, pady=5, sticky="w")

        # Create the back button on the bottom left of the window
        self.back_button = ttk.Button(self.graph_windows, text="Back", font=(
            "Bubblegum", 12), background='#C1D5F0', foreground='#000000', command=self.back_from_graph)
        self.back_button.grid(row=3, column=0, padx=10, pady=10, sticky="sw")

        # Create a save button that are next to the back button
        self.save_button = ttk.Button(self.graph_windows, text="Save", font=(
            "Bubblegum", 12), background='#C1D5F0', foreground='#000000', command=self.save_graph)
        self.save_button.grid(row=3, column=0, padx=10, pady=10, sticky="se")

        # Set the default value of the graph type radio button
        self.graph_type.set("Bar")
        # bind the graph type radio button to the show_hide_country function
        self.show_hide_country(self.graph_type.get())
        self.graph_type.trace("w", self.show_hide_country)
        

    def show_hide_country(self, *args):
        """
        Enable or disable the country_filter Combobox based on the selected radio button.
        """
        if self.graph_type.get() == "Network":
            self.graph_region.set("")
            self.country_filter.set("")
            self.graph_option.set("")
            self.country_filter.config(state='disabled')
            self.graph_option.config(state='disabled')
            self.plot_button.configure(command=self.update_network_graph)
            self.save_button.grid_forget()
            self.canvas.get_tk_widget().grid_forget()
            self.network_button.configure(state='disabled')
            self.bar_button.configure(state='normal')

        else:
            self.graph_region.set("")
            self.country_filter.set("")
            self.graph_option.set("")
            self.country_filter.config(state='readonly')
            self.graph_option.config(state='readonly')
            self.plot_button.configure(command=self.update_graph)
            self.save_button.grid(row=3, column=0, padx=10, pady=10, sticky="se")
            self.figure = Figure(figsize=(5, 5), dpi=100)
            self.axes = self.figure.add_subplot(111)
            self.canvas = FigureCanvasTkAgg(self.figure, self.graph_windows)
            self.canvas.get_tk_widget().grid(row=2, column=0, padx=10, pady=10, sticky="nsew")
            self.bar_button.configure(state='disabled')
            self.network_button.configure(state='normal')
            self.reset_graph()

    def save_graph(self):
        """
        Save the graph
        """
        file = filedialog.asksaveasfilename(defaultextension=".png", filetypes=[("PNG", "*.png"), ("JPEG", "*.jpg")])
        if file != "":
            self.figure.savefig(file)
            messagebox.showinfo("Success", "Graph saved successfully")
        else:
            messagebox.showerror("Error", "Failed to save graph")


    

    def update_pandas(self, region):
        """
        Update the data in the pandas
        """
        rg = region
        if rg == "":
            pass
        else:
            self.table.model.df = self.happinessctrl.filter_region(rg)
            self.table.redraw()

    def reset_data_table(self):
        """
        Reset the data in the pandas table
        """
        self.region_filter.set("")
        self.table.model.df = self.happinessctrl.filter_data()
        self.table.redraw()

    def reset_data(self):
        """
        Refresh the graph window
        """
        # Create a Toplevel window to show the progress bar
        self.progress_window = tk.Toplevel(self)
        self.progress_window.title("Resetting Data...")
        self.progress_window.geometry("300x50")
        self.progress_window.resizable(0, 0)
        self.progress_window['background'] = '#C1D5F0'
        self.graph_windows.withdraw()
        self.progress_bar = Progressbar(self.progress_window, orient="horizontal", length=280, mode="indeterminate")
        self.progress_bar.pack(pady=10)

        # Start the progress bar
        self.progress_bar.start()
    
        # Create a new thread to reset the data
        self.reset_thread = threading.Thread(target=self.reset_data_thread, args=(self.progress_window, self.progress_bar))
        self.reset_thread.start()

    def reset_data_thread(self, progress_window, progress_bar):
        """
        A thread that resets the data and updates the graph window.
        """
        # Simulate resetting the data
        time.sleep(2)
    
        # Stop the progress bar and close the progress window
        progress_bar.stop()
        progress_window.destroy()
    
        # Update the graph window
        self.graph_windows.destroy()
        # Re-open the graph window and clear all the filters
        self.deiconify()
        self.graph_window()
        
    def reset_graph(self):
        """
        Reset the graph
        """
        # reset plotted countries
        self.plotted_countries = []
        self.current_graph_option = None

    def back_from_info(self):
        """
        Close the info window and open the main window
        """
        self.info_window.destroy()
        self.deiconify()

    def back_from_graph(self):
        """
        Close the graph window and open the main window
        """
        self.graph_windows.destroy()
        self.deiconify()

    def country_option(self, event):
        """
        Country option that are from the selected region
        """
        r_name = self.graph_region.get()
        c_combo = self.happinessctrl.country_list_with_region(r_name)
        self.country_filter['values'] = c_combo
        return c_combo

    def update_graph(self):
        """
        Plot the graph based on the filter
        """
        c1 = self.country.get()
        r1 = self.graph_region.get()
        g1 = self.graph_option.get()
        g2 = self.graph_type.get()
        if c1 == "" or r1 == "" or g1 == "" or g2 == "":
            messagebox.showerror("Error", "Please fill all the filters")
        else:
            if g2 == "Bar":
                """ If the graph type is bar, then plot a bar graph"""
                if not hasattr(self, "plotted_countries") or g1 != self.current_graph_option:
                    # First time plotting or switching graph options, create new graph
                    self.plotted_countries = [c1]
                    self.current_graph_option = g1
                    self.axes.clear()
                    self.axes.set_title(f"{g1}")
                    self.axes.set_xlabel("Country")
                    self.axes.set_ylabel(f"{g1}")
                else:
                    # Break, Check if country has already been plotted or if max number of countries already plotted
                    if c1 in self.plotted_countries:
                        messagebox.showerror(
                            "Error", "Country already plotted")
                        return
                    elif len(self.plotted_countries) >= 5:
                        messagebox.showerror(
                            "Error", "Maximum number of countries plotted")
                        return
                    else:
                        self.plotted_countries.append(c1)
                # Plot selected country
                data = self.happinessctrl.get_plotted_data(c1, g1)
                try:
                    # Adjust the bar width
                    self.axes.bar(c1, data, width=0.5)
                    self.axes.bar_label(
                        self.axes.containers[-1], labels=data, label_type="edge", fontsize=8, padding=5)
                    self.canvas.draw()
                except tkinter.TclError as e:
                    messagebox.showerror(
                        "Error", f"Failed to update plot: {str(e)}")
                    
    def update_network_graph(self):
        """
        Update the network graph and show the graph
        """
        r1 = self.graph_region.get()
        if r1 == "":
            messagebox.showerror("Error", "Please select the region")
        else:
            G = nx.Graph()
            # Center node which is the region
            G.add_node(r1)
            # Add the edge between the region and the country
            for i in self.happinessctrl.country_list_with_region(r1):
                G.add_edge(r1, i)

            # Plot the graph
            nx.draw(G, with_labels=True, font_weight='bold')
            plt.show()
            
    def run(self):
        '''
        Run the application
        '''
        self.mainloop()
