from Happiness_data import Happiness as hd

class HappinessCtrl:

    def __init__(self, happiness_data: hd):
        """
        Initialize the data
        """
        self.happiness_data = happiness_data.get_data()
      
    def country_list_with_region(self, region):
        """
        Return the country list
        """
        return self.happiness_data[self.happiness_data['Region'] == region]['Country'].unique().tolist()
    
    def region_country_list(self):
        """
        Return the region and country list
        """
        return self.happiness_data[['Region', 'Country']].values.tolist()

    def region_list(self):
        """
        Return the region list
        """
        return self.happiness_data['Region'].unique().tolist()

    
    def filter_region(self, region):
        """
        Filter the data by region
        """
        return self.happiness_data[self.happiness_data['Region'] == region][['Country', 'Happiness Score', 'Economy (GDP per Capita)', 'Family', 'Health (Life Expectancy)', 'Freedom', 'Trust (Government Corruption)', 'Generosity', 'Dystopia Residual']]
    
    def filter_data(self):
        """
        A data that show the Country with Happiness Score
        """
        return self.happiness_data[['Country', 'Happiness Score', 'Economy (GDP per Capita)', 'Family', 'Health (Life Expectancy)', 'Freedom', 'Trust (Government Corruption)', 'Generosity', 'Dystopia Residual']]
    
    def option(self):
        """
        An option to choose to plot a graph
        """
        return self.happiness_data.columns[3:].tolist()


    def get_plotted_data(self, c1, g1):
        """
        Get all the data to plot
        """
        return self.happiness_data[self.happiness_data['Country'] == c1][g1]
    
    def defocus(self, event):
        """
        Defocus the widget
        """
        event.widget.master.focus_set()


    
                

                




    


   
        


    
    

