# Happiness Around the World
 
## Description
The application is about Happiness Ranking around the world. The program will divided into 2 parts which is 
the first part is the data interface and the second part is the graph interface. The data interface will show the
data of the happiness ranking around the world and the graph interface will show the graph.

## Data Sources 
The data source is from Kaggle which is the World Happiness Report 2015. The data is in csv format and it is from https://www.kaggle.com/datasets/unsdsn/world-happiness
 
## Running the Application
The requirement program to run this project you must have 
### Python
* [Python 3.10](https://www.python.org/downloads/)
### pandas
* [pandas](https://pandas.pydata.org/docs/getting_started/install.html)
### Matplotlib
* [Matplotlib](https://matplotlib.org/stable/users/installing/index.html)
### pandastable
* [pandastable](https://pandastable.readthedocs.io/en/latest/description.html)
The packages are listed in the file name requirements.txt.
The user can download the packages by using the following command:

```
pip install -r requirements.txt
```
**Note :** You can use an older version python but not recommended, to run the application, please run in [`Main.py`](Main.py)

**Note 2 :** Also, you must download the font that I'm using in the program which is Bubblegum. You can download it from the link below.
### Bubblegum
* [Bubblegum](https://www.dafont.com/bubblegum.font)

## Design
<!-- Describe the overall design, including a UML class diagram and a sequence
diagram of a selected scenario. -->
* The design of the program is divided into 2 parts which is the data interface and the graph interface.
* The data interface will show the data of the happiness ranking around the world and the graph interface will show the graph.

### UML Class Diagram
![UML Class Diagram](imgs/UML.png)

### Sequence Diagram
![Sequence Diagram](imgs/Sequence.png)

 
## Design Patterns Used

I'm using 
* Dependency Injection : I'm using dependency injection because it is easier to maintain and it is also easier to figure out the error and encounter the bug.
* Observer : Using to update the data in the table and graph based on the selection from the user.
* State : Using to change the type of plotting the graph based on the selection from the user in the graph interfaces.
* Composite : Using to make the container for the widgets in the graph interfaces.
* Facade : Using to make that the user can only access the interface that they want to access.

 
## Graph Algorithm Used
The graph algorithm that I'm using is the Dijkstra's algorithm. I'm using this algorithm because it is the shortest path algorithm and it is also the most efficient algorithm to find the shortest path. I'm using this algorithm to find the shortest path from the source to the destination. The source is the country that the user choose and the destination is the country that the user choose. The algorithm will find the shortest path from the source to the destination and it will show the path in the graph.

 
## Other Information
From this, I've learned alot of how to use the combination of the both pandas and tkinter to make an gui application that can show the data and graph. I've also learned how to use the design pattern to make the program more easier to maintain and easier to figure out the error and encounter the bug. I've also learned how to use the graph algorithm to solve the problem.
